## ros-foxy-maliput-ros 0.1.1

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_ros LANGUAGES C CXX VERSION 0.1.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)
find_package(maliput REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(maliput_ros_interfaces REQUIRED)
find_package(maliput_ros_translation REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(yaml-cpp REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

ament_environment_hooks(
  "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
)

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
    ament_doxygen_generate(doxygen_maliput_ros
      CONFIG_OVERLAY doc/Doxyfile.overlay.in
      TEST_ON_WARNS
    )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Export
##############################################################################

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)

install(DIRECTORY
  launch
  DESTINATION share/${PROJECT_NAME}/
)

install(DIRECTORY
  resources
  DESTINATION share/${PROJECT_NAME}/
)

ament_environment_hooks(setup.sh.in)
ament_export_dependencies(ament_cmake)
ament_export_dependencies(lifecycle_msgs)
ament_export_dependencies(maliput)
ament_export_dependencies(maliput_ros_interfaces)
ament_export_dependencies(maliput_ros_translation)
ament_export_dependencies(rclcpp)
ament_export_dependencies(rclcpp_lifecycle)
ament_export_dependencies(yaml-cpp)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)
ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(maliput_ros)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_gmock REQUIRED)
add_subdirectory(maliput_ros)

=== src/maliput_ros/CMakeLists.txt ===
add_subdirectory(ros)
add_subdirectory(utils)

=== src/maliput_ros/ros/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

add_library(maliput_ros_node
  maliput_query_node.cc
)

add_library(maliput_ros::maliput_ros_node ALIAS maliput_ros_node)

set_target_properties(maliput_ros_node
  PROPERTIES
    OUTPUT_NAME maliput_ros_node
)

target_include_directories(maliput_ros_node
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

ament_target_dependencies(maliput_ros_node
  maliput
  maliput_ros_interfaces
  maliput_ros_translation
  rclcpp
  rclcpp_lifecycle
)

target_link_libraries(maliput_ros_node
  maliput_ros::utils
)

add_executable(maliput_ros
  maliput_query_server.cc
)

target_include_directories(maliput_ros
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

ament_target_dependencies(maliput_ros
  rclcpp
  rclcpp_lifecycle
)

target_link_libraries(maliput_ros
  maliput_ros::maliput_ros_node
)

##############################################################################
# Export
##############################################################################

install(
  TARGETS maliput_ros_node
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

install(
  TARGETS maliput_ros
  EXPORT ${PROJECT_NAME}-targets
  DESTINATION lib/${PROJECT_NAME}
)

=== src/maliput_ros/utils/CMakeLists.txt ===
add_library(utils
  yaml_parser.cc
)

add_library(maliput_ros::utils ALIAS utils)
set_target_properties(utils
  PROPERTIES
    OUTPUT_NAME maliput_ros_utils
)

target_link_libraries(utils
  maliput::common
  yaml-cpp
)

target_include_directories(utils
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)

install(
  TARGETS utils
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== test/maliput_ros/ros/CMakeLists.txt ===
# It is necessary to find gmock via this macro so GMOCK_INCLUDE_DIRS and GMOCK_LIBRARIES are populated.
# That way, we can use gmock linked to libraries that will be used by test executables later on.
ament_find_gmock()

add_library(maliput_ros_plugin_config_test
    maliput_plugin_config_test.cc
)

add_library(maliput_ros::maliput_ros_plugin_config_test ALIAS maliput_ros_plugin_config_test)

set_target_properties(maliput_ros_plugin_config_test
  PROPERTIES
    OUTPUT_NAME maliput_ros_plugin_config_test
)

target_link_libraries(maliput_ros_plugin_config_test
    maliput::api
    maliput::plugin
    ${GMOCK_LIBRARIES}
)

target_include_directories(maliput_ros_plugin_config_test
  PRIVATE
    ${PROJECT_SOURCE_DIR}/test
    "${GMOCK_INCLUDE_DIRS}"
)

add_library(maliput_ros_road_network_plugin
    maliput_ros_road_network_plugin.cc
)

add_library(maliput_ros::maliput_ros_road_network_plugin ALIAS maliput_ros_road_network_plugin)

set_target_properties(maliput_ros_road_network_plugin
  PROPERTIES
    OUTPUT_NAME maliput_ros_road_network_plugin
)

target_link_libraries(maliput_ros_road_network_plugin
    maliput::api
    maliput::plugin
    maliput_ros_plugin_config_test
    ${GMOCK_LIBRARIES}
)

target_include_directories(maliput_ros_road_network_plugin
  PRIVATE
    ${PROJECT_SOURCE_DIR}/test
    "${GMOCK_INCLUDE_DIRS}"
)

set(TEST_PLUGIN_INSTALL_DIR "/tmp/maliput_ros/test/plugins/")
set(TEST_YAML_CONFIGURATION_PLUGIN_INSTALL_PATH "${CMAKE_CURRENT_SOURCE_DIR}/test_maliput_plugin.yml")

install(
  TARGETS maliput_ros_road_network_plugin
  ARCHIVE DESTINATION ${TEST_PLUGIN_INSTALL_DIR}
  LIBRARY DESTINATION ${TEST_PLUGIN_INSTALL_DIR}
  RUNTIME DESTINATION ${TEST_PLUGIN_INSTALL_DIR}
)

ament_add_gmock(branch_point_service_test branch_point_service_test.cc)
ament_add_gmock(junction_service_test junction_service_test.cc)
ament_add_gmock(lane_geometry_services_test lane_geometry_services_test.cc)
ament_add_gmock(lane_service_test lane_service_test.cc)
ament_add_gmock(maliput_query_test maliput_query_test.cc)
ament_add_gmock(maliput_query_node_test maliput_query_node_test.cc)
ament_add_gmock(path_services_test path_services_test.cc)
ament_add_gmock(road_geometry_service_test road_geometry_service_test.cc)
ament_add_gmock(road_position_service_test road_position_service_test.cc)
ament_add_gmock(segment_service_test segment_service_test.cc)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/test
      )

      ament_target_dependencies(${target}
          lifecycle_msgs
          maliput
          rclcpp
          rclcpp_lifecycle
      )

      target_link_libraries(${target}
          maliput::plugin
          maliput::test_utilities
          maliput_ros::maliput_ros_node
          maliput_ros::maliput_ros_plugin_config_test
          maliput_ros_translation::maliput_ros_translation
      )

      target_compile_definitions(${target}
        PRIVATE
          TEST_MALIPUT_PLUGIN_LIBDIR="${TEST_PLUGIN_INSTALL_DIR}"
          TEST_YAML_CONFIGURATION_PLUGIN_INSTALL_PATH="${TEST_YAML_CONFIGURATION_PLUGIN_INSTALL_PATH}"
      )
    endif()
endmacro()

add_dependencies_to_test(branch_point_service_test)
add_dependencies_to_test(junction_service_test)
add_dependencies_to_test(lane_geometry_services_test)
add_dependencies_to_test(lane_service_test)
add_dependencies_to_test(maliput_query_test)
add_dependencies_to_test(maliput_query_node_test)
add_dependencies_to_test(path_services_test)
add_dependencies_to_test(road_geometry_service_test)
add_dependencies_to_test(road_position_service_test)
add_dependencies_to_test(segment_service_test)

=== test/maliput_ros/utils/CMakeLists.txt ===
ament_add_gtest(yaml_parser_test yaml_parser_test.cc)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${PROJECT_SOURCE_DIR}/src
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
          maliput::common
          maliput_ros::utils
      )

    endif()
endmacro()

add_dependencies_to_test(yaml_parser_test)

=== debian/changelog ===
ros-foxy-maliput-ros (0.1.1-1focal) focal; urgency=high

  * Adds READMEs to the packages. (#24 <https://github.com/maliput/ros2_maliput/issues/24>)
  * Sample lane s route (#21 <https://github.com/maliput/ros2_maliput/issues/21>)
  * Routing service (#20 <https://github.com/maliput/ros2_maliput/issues/20>)
  * Road position services (#19 <https://github.com/maliput/ros2_maliput/issues/19>)
  * Refactor tests to scale build time (#18 <https://github.com/maliput/ros2_maliput/issues/18>)
  * Adds branch point service (#17 <https://github.com/maliput/ros2_maliput/issues/17>)
  * Adds lane service (#16 <https://github.com/maliput/ros2_maliput/issues/16>)
  * Add get segment service (#15 <https://github.com/maliput/ros2_maliput/issues/15>)
  * Add get junction service (#14 <https://github.com/maliput/ros2_maliput/issues/14>)
  * Add tests to ROS node (#10 <https://github.com/maliput/ros2_maliput/issues/10>)
  * Create maliput ros node (#8 <https://github.com/maliput/ros2_maliput/issues/8>)
  * Create maliput_ros package (#7 <https://github.com/maliput/ros2_maliput/issues/7>)
  * Contributors: Agustin Alba Chicar

 -- Agustin Alba Chicar <ag.albachicar@ekumenlabs.com>  Mon, 17 Apr 2023 03:00:00 -0000

=== debian/control ===
Source: ros-foxy-maliput-ros
Section: misc
Priority: optional
Maintainer: Agustin Alba Chicar <ag.albachicar@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), libyaml-cpp-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-lifecycle-msgs, ros-foxy-maliput, ros-foxy-maliput-ros-interfaces, ros-foxy-maliput-ros-translation, ros-foxy-rclcpp, ros-foxy-rclcpp-lifecycle, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-cpp-dev, ros-foxy-launch-ros, ros-foxy-lifecycle-msgs, ros-foxy-maliput, ros-foxy-maliput-ros-interfaces, ros-foxy-maliput-ros-translation, ros-foxy-rclcpp, ros-foxy-rclcpp-lifecycle, ros-foxy-ros2launch, ros-foxy-ros-workspace
Description: ROS2 integration package which offers the maliput API through the ROS2 service interface.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-ros//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
